﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.ComponentModel;
using Infragistics.Windows.DataPresenter;
using System.Collections.ObjectModel;

namespace XamDataGridCommand
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            this.DataContext = TryFindResource("data") as ViewModel;
        }

        private void comboBox1_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            Random rand = new Random();
            (this.DataContext as ViewModel).GridDataValue.Add(new GridData { FirstName = "mat", MiddleNameName = "Grid" + rand.Next(50).ToString(), LastNameWithEmailID = "test" + rand.Next(50).ToString() });
            (this.DataContext as ViewModel).GridDataValue.Add(new GridData { FirstName = "pat", MiddleNameName = "Grid" + rand.Next(50).ToString(), LastNameWithEmailID = "test" + rand.Next(50).ToString() });
            (this.DataContext as ViewModel).GridDataValue.Add(new GridData { FirstName = "gat", MiddleNameName = "Grid" + rand.Next(50).ToString(), LastNameWithEmailID = "test" + rand.Next(50).ToString() });
            (this.DataContext as ViewModel).ColumnName = "working " + rand.Next(50).ToString();
        }
    }

    public class ViewModel : INotifyPropertyChanged
    {
        private ObservableCollection<GridData> gridDataValue;
        private string columnName;

        public ViewModel()
        {
            ConstructData();
        }

        public string ColumnName
        {
            get
            {
                return this.columnName;
            }

            set
            {
                if (value != this.columnName)
                {
                    this.columnName = value;
                    NotifyPropertyChanged("ColumnName");
                }
            }
        }

        public ObservableCollection<GridData> GridDataValue
        {
            get { return gridDataValue; }
            set
            {
                gridDataValue = value;
                NotifyPropertyChanged("GridDataValue");
            }
        }

        public void ConstructData()
        {
            ColumnName = "First Column Text";
            GridDataValue = new ObservableCollection<GridData>();
            GridDataValue.Add(new GridData { FirstName = "mat", MiddleNameName = "Grid1", LastNameWithEmailID = "test1" });
            GridDataValue.Add(new GridData { FirstName = "pat", MiddleNameName = "Grid2", LastNameWithEmailID = "test3" });
            GridDataValue.Add(new GridData { FirstName = "gat", MiddleNameName = "Grid3", LastNameWithEmailID = "test45" });
        }


        public event PropertyChangedEventHandler PropertyChanged;

        protected virtual void NotifyPropertyChanged(string propertyName)
        {
            PropertyChangedEventHandler handler = this.PropertyChanged;
            if (handler != null)
            {
                var e = new PropertyChangedEventArgs(propertyName);
                handler(this, e);
            }
        }
    }

    public class GridData : INotifyPropertyChanged
    {
        private string firstName;
        private string middleNameName;
        private string lastNameWithEmailID;

        public string FirstName
        {
            get
            {
                return this.firstName;
            }

            set
            {
                if (value != this.firstName)
                {
                    this.firstName = value;
                    NotifyPropertyChanged("FirstName");
                }
            }
        }

        public string MiddleNameName
        {
            get
            {
                return this.middleNameName;
            }

            set
            {
                if (value != this.middleNameName)
                {
                    this.middleNameName = value;
                    NotifyPropertyChanged("MiddleNameName");
                }
            }
        }
        public string LastNameWithEmailID
        {
            get
            {
                return this.lastNameWithEmailID;
            }

            set
            {
                if (value != this.lastNameWithEmailID)
                {
                    this.lastNameWithEmailID = value;
                    NotifyPropertyChanged("LastNameWithEmailID");
                }
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        protected virtual void NotifyPropertyChanged(string propertyName)
        {
            PropertyChangedEventHandler handler = this.PropertyChanged;
            if (handler != null)
            {
                var e = new PropertyChangedEventArgs(propertyName);
                handler(this, e);
            }
        }
    }

    public class MyConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            return "ale";
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }


}
